
/*
 * @(#)ComponentType.java
 *
 * Generated by <a href="http://lci.cs.ubbcluj.ro/ocle/>OCLE 2.0</a>
 * using <a href="http://jakarta.apache.org/velocity/">
 * Velocity Template Engine 1.3rc1</a>
 */
package CCMM.Core;
import CCMM.Architecture.Architecture;
import CCMM.Basic.NamedElement;
import CCMM.Basic.Type;
import CCMM.Repository.Repository;
import java.util.Iterator;
import java.util.LinkedHashSet;
import java.util.Set;
import ro.ubbcluj.lci.codegen.framework.ocl.BasicConstraintChecker;
import ro.ubbcluj.lci.codegen.framework.ocl.CollectionUtilities;

/**
 *
 * @author unascribed
 */
public class ComponentType extends NamedElement
{

    
    public final Set getProvidedInterfaces()
    {

        if (providedInterfaces == null) {
            return java.util.Collections.EMPTY_SET;
        }
        return java.util.Collections.unmodifiableSet(providedInterfaces);
    }
    
    public final void addProvidedInterfaces(Interface arg)
    {

        if (arg != null) {
            if (providedInterfaces == null) {
                providedInterfaces = new LinkedHashSet();
            }
            if (providedInterfaces.add(arg)) {
                arg.setPComponentType(this);
            }
        }

    }
    
    public final void removeProvidedInterfaces(Interface arg)
    {

        if (providedInterfaces != null && arg != null) {
            if (providedInterfaces.remove(arg)) {
                arg.setPComponentType(null);
            }
        }

    }
    
    public final Set getRequiredInterfaces()
    {

        if (requiredInterfaces == null) {
            return java.util.Collections.EMPTY_SET;
        }
        return java.util.Collections.unmodifiableSet(requiredInterfaces);
    }
    
    public final void addRequiredInterfaces(Interface arg)
    {

        if (arg != null) {
            if (requiredInterfaces == null) {
                requiredInterfaces = new LinkedHashSet();
            }
            if (requiredInterfaces.add(arg)) {
                arg.setRComponentType(this);
            }
        }

    }
    
    public final void removeRequiredInterfaces(Interface arg)
    {

        if (requiredInterfaces != null && arg != null) {
            if (requiredInterfaces.remove(arg)) {
                arg.setRComponentType(null);
            }
        }

    }
    
    public final Architecture getArchitecture()
    {

        return architecture;
    }
    
    public final void setArchitecture(Architecture arg)
    {

        if (architecture != arg) {
            Architecture temp = architecture;
            architecture = null;//to avoid infinite recursion
            if (temp != null) {
                temp.setComponentType(null);
            }
            if (arg != null) {
                architecture = arg;
                arg.setComponentType(this);
            }
        }

    }
    
    public final Repository getRepository()
    {

        return repository;
    }
    
    public final void setRepository(Repository arg)
    {

        if (repository != arg) {
            Repository temp = repository;
            repository = null;//to avoid infinite recursions
            if (temp != null) {
                temp.removeComponentTypes(this);
            }
            if (arg != null) {
                repository = arg;
                arg.addComponentTypes(this);
            }
        }

    }
    
    public ComponentType()
    {

    }
    
    public class ConstraintChecker extends BasicConstraintChecker
    {

        
        public void checkConstraints()
        {

            super.checkConstraints();
            check_CCMM_Core_ComponentType_invDistinctInterfaceNames();
            check_CCMM_Core_ComponentType_invDistinctRepositoryNames3();

        }
        
        public void check_CCMM_Core_ComponentType_invDistinctInterfaceNames()
        {

            Set setProvidedInterfaces = ComponentType.this.getProvidedInterfaces();
            Set setRequiredInterfaces = ComponentType.this.getRequiredInterfaces();
            Set setUnion = CollectionUtilities.union(setProvidedInterfaces, setRequiredInterfaces);
            //evaluate 'isUnique(i|i.name)':
            Set uniquenessValidator = CollectionUtilities.newSet();
            boolean bIsUnique = true;
            final Iterator iter = setUnion.iterator();
            while (bIsUnique && iter.hasNext())
            {
                final Interface i = (Interface)iter.next();
                String strName = i.name;
                
                bIsUnique = uniquenessValidator.add(strName);
            }
            if (!bIsUnique)
            {
                System.err.println("invariant 'invDistinctInterfaceNames' failed for object "+ComponentType.this);
            }

        }
        
        public void check_CCMM_Core_ComponentType_invDistinctRepositoryNames3()
        {

            Repository repositoryRepository = ComponentType.this.getRepository();
            Set setTypes = repositoryRepository.getTypes();
            //evaluate 'select(t|t.name=self.name)':
            Set setSelect = CollectionUtilities.newSet();
            final Iterator iter = setTypes.iterator();
            while (iter.hasNext())
            {
                final Type t = (Type)iter.next();
                String strName = t.name;
                String strName0 = ComponentType.this.name;
                boolean bEquals0 = strName.equals(strName0);
                
                if (bEquals0) CollectionUtilities.add(setSelect, t);
            }
            int nSize = CollectionUtilities.size(setSelect);
            boolean bEquals = nSize == 0;
            Repository repositoryRepository0 = ComponentType.this.getRepository();
            Set setInterfaceTypes = repositoryRepository0.getInterfaceTypes();
            //evaluate 'select(it|it.name=self.name)':
            Set setSelect0 = CollectionUtilities.newSet();
            final Iterator iter0 = setInterfaceTypes.iterator();
            while (iter0.hasNext())
            {
                final InterfaceType it = (InterfaceType)iter0.next();
                String strName1 = it.name;
                String strName2 = ComponentType.this.name;
                boolean bEquals2 = strName1.equals(strName2);
                
                if (bEquals2) CollectionUtilities.add(setSelect0, it);
            }
            int nSize0 = CollectionUtilities.size(setSelect0);
            boolean bEquals1 = nSize0 == 0;
            boolean bAnd0 = bEquals && bEquals1;
            Repository repositoryRepository1 = ComponentType.this.getRepository();
            Set setComponentTypes = repositoryRepository1.getComponentTypes();
            //evaluate 'select(ct|ct.name=self.name)':
            Set setSelect1 = CollectionUtilities.newSet();
            final Iterator iter1 = setComponentTypes.iterator();
            while (iter1.hasNext())
            {
                final ComponentType ct = (ComponentType)iter1.next();
                String strName3 = ct.name;
                String strName4 = ComponentType.this.name;
                boolean bEquals4 = strName3.equals(strName4);
                
                if (bEquals4) CollectionUtilities.add(setSelect1, ct);
            }
            int nSize1 = CollectionUtilities.size(setSelect1);
            boolean bEquals3 = nSize1 == 1;
            boolean bAnd = bAnd0 && bEquals3;
            if (!bAnd)
            {
                System.err.println("invariant 'invDistinctRepositoryNames3' failed for object "+ComponentType.this);
            }

        }

    }
    
    public Set providedInterfaces;
    
    public Set requiredInterfaces;
    
    public Architecture architecture;
    
    public Repository repository;

}
